package de.duehl.swing.ui.layout.card;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JPanel;

/*
 * Copyright 2016 Christian Dühl. All rights reserved.
 *
 * This program is free software. You can redistribute it and/or
 * modify it under the same terms as perl:
 *
 * general:  http://dev.perl.org/licenses/
 * GPL:      http://dev.perl.org/licenses/gpl1.html
 * artistic: http://dev.perl.org/licenses/artistic.html
 */

public abstract class CardsBase {

    private final List<Card> cards;

    protected CardsBase() {
        cards = new ArrayList<>();
    }

    protected void addCard(Card card) {
        cards.add(card);
    }

    Card getNext(Card currentCard) {
        int currentIndex = cards.indexOf(currentCard);
        int nextIndex = currentIndex + 1;
        if (nextIndex >= cards.size()) {
            throw new RuntimeException("Keine weitere Karte vorhanden.");
        }
        Card card = cards.get(nextIndex);
        return card;
    }

    void addAllCardsToPanel(JPanel panel, CardSwitcher switcher) {
        for (Card card : cards) {
            panel.add(card.createCardGui(switcher), card.getName());
        }
    }

    Card getFirstCard() {
        return cards.get(0);
    }

}
